Index: /LMDZ6/trunk/libf/dyn3d_common/infotrac.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3d_common/infotrac.F90	(revision 4168)
+++ /LMDZ6/trunk/libf/dyn3d_common/infotrac.F90	(revision 4169)
@@ -201,5 +201,5 @@
     
    CALL msg('type_trac = "'//TRIM(type_trac)//'"', modname)
-   IF(strParse(type_trac, ',', str, n=nt)) CALL abort_gcm(modname,'can''t parse "type_trac = '//TRIM(type_trac)//'"',1)
+   IF(strParse(type_trac, '|', str, n=nt)) CALL abort_gcm(modname,'can''t parse "type_trac = '//TRIM(type_trac)//'"',1)
 
    !---------------------------------------------------------------------------------------------------------------------------
@@ -238,11 +238,11 @@
       END SELECT
 
-      !--- DISABLE "config_inca" OPTION FOR A RUN WITHOUT "INCA" IF IT DIFFERS FROM "none"
-      IF(fmsg('Setting config_inca="none" as you do not couple with INCA model', &
-              modname, ALL(['inca', 'inco'] /= str(it)) .AND. config_inca /= 'none')) config_inca = 'none'
-
    !---------------------------------------------------------------------------------------------------------------------------
    END DO
    !---------------------------------------------------------------------------------------------------------------------------
+
+   !--- DISABLE "config_inca" OPTION FOR A RUN WITHOUT "INCA" IF IT DIFFERS FROM "none"
+   IF(fmsg('Setting config_inca="none" as you do not couple with INCA model', &
+           modname, ALL(str /= 'inca') .AND. ALL(str /= 'inco') .AND. config_inca /= 'none')) config_inca = 'none'
 
    nqCO2 = 0; IF(ANY(str == 'inco')) nqCO2 = 1
Index: /LMDZ6/trunk/libf/misc/readTracFiles_mod.f90
===================================================================
--- /LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 4168)
+++ /LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 4169)
@@ -107,5 +107,5 @@
 
   !--- Required sections + corresponding files names (new style single section case)
-  IF(test(strParse(type_trac, ',', sections), lerr)) RETURN          !--- Parse "type_trac" list
+  IF(test(strParse(type_trac, '|', sections), lerr)) RETURN          !--- Parse "type_trac" list
 
   nsec = SIZE(sections, DIM=1)
@@ -193,5 +193,5 @@
 !==============================================================================================================================
 LOGICAL FUNCTION feedDBase(fnames, snames, modname) RESULT(lerr)
-! Purpose: Read the sections "snames(is)" (coma-separated list) from each "fnames(is)"
+! Purpose: Read the sections "snames(is)" (pipe-separated list) from each "fnames(is)"
 !   file and create the corresponding tracers set descriptors in the database "dBase":
 ! * dBase(id)%name                : section name
@@ -201,5 +201,5 @@
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=*), INTENT(IN)  :: fnames(:)                         !--- Files names
-  CHARACTER(LEN=*), INTENT(IN)  :: snames(:)                         !--- Coma-deparated list of sections (one list each file)
+  CHARACTER(LEN=*), INTENT(IN)  :: snames(:)                         !--- Pipe-deparated list of sections (one list each file)
   CHARACTER(LEN=*), INTENT(IN)  :: modname                           !--- Calling routine name
   INTEGER,  ALLOCATABLE :: ndb(:)                                    !--- Number of sections for each file
@@ -211,5 +211,5 @@
 !------------------------------------------------------------------------------------------------------------------------------
   !=== READ THE REQUIRED SECTIONS
-  ll = strCount(snames, ',', ndb)                                    !--- Number of sections for each file
+  ll = strCount(snames, '|', ndb)                                    !--- Number of sections for each file
   ALLOCATE(ixf(SUM(ndb)))
   DO i=1, SIZE(fnames)                                               !--- Set %name, %keys
@@ -239,5 +239,5 @@
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=*),           INTENT(IN) :: fnam                     !--- File name
-  CHARACTER(LEN=*),           INTENT(IN) :: snam                     !--- Coma-separated sections list
+  CHARACTER(LEN=*),           INTENT(IN) :: snam                     !--- Pipe-separated sections list
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: defName                  !--- Special section (default values) name
 !------------------------------------------------------------------------------------------------------------------------------
@@ -254,5 +254,5 @@
     DO idb=n0,ndb; CALL addDefault(dBase(idb)%trac, defName); END DO !--- and remove the virtual tracer "defName"
   END IF
-  ll = strParse(snam, ',', keys = sec)                               !--- Requested sections names
+  ll = strParse(snam, '|', keys = sec)                               !--- Requested sections names
   ix = strIdx(dBase(:)%name, sec(:))                                 !--- Indexes of requested sections in database
   IF(test(checkList(sec, ix == 0, 'In file "'//TRIM(fnam)//'"','section(s)', 'missing'), lerr)) RETURN
@@ -893,5 +893,5 @@
   !--- READ THE FILE SECTIONS, ONE EACH PARENT TRACER
   nb0 = SIZE(dBase, DIM=1)+1                                         !--- Next database element index
-  IF(test(readSections(fnam,strStack(isot(:)%parent,',')),lerr)) RETURN !--- Read sections, one each parent tracer
+  IF(test(readSections(fnam,strStack(isot(:)%parent,'|')),lerr)) RETURN !--- Read sections, one each parent tracer
   ndb = SIZE(dBase, DIM=1)                                           !--- Current database size
   DO idb = nb0, ndb