Index: LMDZ6/trunk/libf/phylmdiso/phyetat0.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/phyetat0.F90	(revision 4158)
+++ LMDZ6/trunk/libf/phylmdiso/phyetat0.F90	(revision 4170)
@@ -31,5 +31,5 @@
   USE geometry_mod,     ONLY: longitude_deg, latitude_deg
   USE iostart,          ONLY: close_startphy, get_field, get_var, open_startphy
-  USE infotrac_phy,     ONLY: nqtot, nbtr, type_trac, tracers
+  USE infotrac_phy,     ONLY: nqtot, nbtr, types_trac, tracers
   USE traclmdz_mod,     ONLY: traclmdz_from_restart
   USE carbon_cycle_mod, ONLY: carbon_cycle_tr, carbon_cycle_cpl, co2_send
@@ -468,5 +468,12 @@
 !===========================================
 
-  IF (type_trac == 'lmdz') THEN
+!--OB now this is for co2i - ThL: and therefore also for inco
+  IF (ANY(types_trac == 'co2i') .OR. ANY(types_trac == 'inco')) THEN
+     IF (carbon_cycle_cpl) THEN
+        ALLOCATE(co2_send(klon), stat=ierr)
+        IF (ierr /= 0) CALL abort_physic('phyetat0', 'pb allocation co2_send', 1)
+        found=phyetat0_get(1,co2_send,"co2_send","co2 send",co2_ppm)
+     ENDIF
+  ELSE IF (ANY(types_trac == 'lmdz')) THEN
      it = 0
      DO iq = 1, nqtot
@@ -477,13 +484,4 @@
      END DO
      CALL traclmdz_from_restart(trs)
-  ENDIF
-
-!--OB now this is for co2i - ThL: and therefore also for inco
-  IF (type_trac == 'co2i' .OR. type_trac == 'inco') THEN
-     IF (carbon_cycle_cpl) THEN
-        ALLOCATE(co2_send(klon), stat=ierr)
-        IF (ierr /= 0) CALL abort_physic('phyetat0', 'pb allocation co2_send', 1)
-        found=phyetat0_get(1,co2_send,"co2_send","co2 send",co2_ppm)
-     ENDIF
   ENDIF
 
Index: LMDZ6/trunk/libf/phylmdiso/phyredem.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/phyredem.F90	(revision 4158)
+++ LMDZ6/trunk/libf/phylmdiso/phyredem.F90	(revision 4170)
@@ -39,5 +39,5 @@
   USE iostart, ONLY: open_restartphy, close_restartphy, enddef_restartphy, put_field, put_var
   USE traclmdz_mod, ONLY : traclmdz_to_restart
-  USE infotrac_phy, ONLY: type_trac, nqtot, tracers, nbtr, niso
+  USE infotrac_phy, ONLY: types_trac, nqtot, tracers, nbtr, niso
 #ifdef ISO
 #ifdef ISOVERIF
@@ -345,16 +345,5 @@
 
 
-    ! trs from traclmdz_mod
-    IF (type_trac == 'lmdz') THEN
-       CALL traclmdz_to_restart(trs)
-       it = 0
-       DO iq = 1, nqtot
-          IF(.NOT.(tracers(iq)%isAdvected .AND. tracers(iq)%isInPhysics)) CYCLE
-          it = it+1
-          CALL put_field(pass,"trs_"//tracers(iq)%name, "", trs(:, it))
-       END DO
-    END IF
-
-    IF (type_trac == 'co2i' .OR. type_trac == 'inco') THEN
+    IF (ANY(types_trac == 'co2i') .OR. ANY(types_trac == 'inco')) THEN
        IF (carbon_cycle_cpl) THEN
           IF (.NOT. ALLOCATED(co2_send)) THEN
@@ -365,4 +354,14 @@
           CALL put_field(pass,"co2_send", "co2_ppm for coupling", co2_send)
        END IF
+
+    ! trs from traclmdz_mod
+    ELSE IF (ANY(types_trac == 'lmdz')) THEN
+       CALL traclmdz_to_restart(trs)
+       it = 0
+       DO iq = 1, nqtot
+          IF(.NOT.(tracers(iq)%isAdvected .AND. tracers(iq)%isInPhysics)) CYCLE
+          it = it+1
+          CALL put_field(pass,"trs_"//tracers(iq)%name, "", trs(:, it))
+       END DO
     END IF
 
Index: LMDZ6/trunk/libf/phylmdiso/phys_output_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/phys_output_mod.F90	(revision 4158)
+++ LMDZ6/trunk/libf/phylmdiso/phys_output_mod.F90	(revision 4170)
@@ -35,5 +35,5 @@
     USE iophy 
     USE dimphy
-    USE infotrac_phy, ONLY: nqtot, tracers, type_trac, niso, ntraciso=>ntiso
+    USE infotrac_phy, ONLY: nqtot, tracers, niso, ntraciso=>ntiso
     USE strings_mod,  ONLY: maxlen
     USE ioipsl
Index: LMDZ6/trunk/libf/phylmdiso/physiq_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/physiq_mod.F90	(revision 4158)
+++ LMDZ6/trunk/libf/phylmdiso/physiq_mod.F90	(revision 4170)
@@ -39,5 +39,5 @@
     USE ioipsl_getin_p_mod, ONLY : getin_p
     USE indice_sol_mod
-    USE infotrac_phy, ONLY: nqtot, nbtr, nqo, tracers, type_trac, nqCO2
+    USE infotrac_phy, ONLY: nqtot, nbtr, nqo, tracers, types_trac, nqCO2
     USE readTracFiles_mod, ONLY: addPhase
     USE strings_mod,  ONLY: strIdx, strStack, int2str
@@ -1539,5 +1539,5 @@
        tau_overturning_th(:)=0.
 
-       IF (type_trac == 'inca' .OR. type_trac == 'inco') THEN
+       IF (ANY(types_trac == 'inca') .OR. ANY(types_trac == 'inco')) THEN
           ! jg : initialisation jusqu'au ces variables sont dans restart
           ccm(:,:,:) = 0.
@@ -2151,5 +2151,5 @@
        !c         ENDDO
        !
-       IF (type_trac == 'inca' .OR. type_trac == 'inco') THEN			! ModThL
+       IF (ANY(types_trac == 'inca') .OR. ANY(types_trac == 'inco')) THEN  ! ModThL
 #ifdef INCA
           CALL VTe(VTphysiq)
@@ -2200,5 +2200,5 @@
        ENDIF
        !
-       IF (type_trac == 'repr') THEN
+       IF (ANY(types_trac == 'repr')) THEN
 #ifdef REPROBUS
           CALL chemini_rep(  &
@@ -2316,5 +2316,5 @@
 
     ! Update time and other variables in Reprobus
-    IF (type_trac == 'repr') THEN
+    IF (ANY(types_trac == 'repr')) THEN
 #ifdef REPROBUS
        CALL Init_chem_rep_xjour(jD_cur-jD_ref+day_ref)
@@ -3582,5 +3582,5 @@
           !
           !>jyg
-          IF (type_trac == 'repr') THEN
+          IF (ANY(types_trac == 'repr')) THEN
              nbtr_tmp=ntra
           ELSE
@@ -5112,5 +5112,5 @@
     ENDDO
 
-    IF (type_trac == 'inca' .OR. type_trac == 'inco') THEN	! ModThL
+    IF (ANY(types_trac == 'inca') .OR. ANY(types_trac == 'inco')) THEN ! ModThL
 #ifdef INCA
        CALL VTe(VTphysiq)
@@ -5168,5 +5168,5 @@
 #endif
     ENDIF !type_trac = inca or inco
-    IF (type_trac == 'repr') THEN
+    IF (ANY(types_trac == 'repr')) THEN
 #ifdef REPROBUS
     !CALL chemtime_rep(itap+itau_phy-1, date0, dtime, itap)
@@ -6264,5 +6264,5 @@
     !
 
-    IF (type_trac=='repr') THEN
+    IF (ANY(types_trac=='repr')) THEN
 !MM pas d'impact, car on recupere q_seri,tr_seri,t_seri via phys_local_var_mod
 !MM                               dans Reprobus
@@ -6430,5 +6430,5 @@
 #endif
     !
-    IF (type_trac == 'inca' .OR. type_trac == 'inco') THEN
+    IF (ANY(types_trac == 'inca') .OR. ANY(types_trac == 'inco')) THEN
 #ifdef INCA
        CALL VTe(VTphysiq)