Index: LMDZ6/trunk/DefLists/isotopes_params.def
===================================================================
--- LMDZ6/trunk/DefLists/isotopes_params.def	(revision 4158)
+++ LMDZ6/trunk/DefLists/isotopes_params.def	(revision 4193)
@@ -1,8 +1,49 @@
 &H2O
-  params                                               deltaO18_oce=0.0                fac_enrichoce18=0.0005               talph1_O18=1137.   talph2_O18=-0.4156  talph3_O18=-2.0667E-3  talps1_O18=11.839  talps2_O18=-0.028244  tkcin0_O18=0.006            tkcin1_O18=0.000285         tkcin2_O18=0.00082          tdifrel_O18=1./0.9723  alpha_liq_sol_O18=1.00291  fac_coeff_eq17_liq=0.529  fac_coeff_eq17_ice=0.529
-  H2[16]O  alpha=1.000  tnat=1.0000     toce=tnat                                      tcorr=1.0                            talph1=0.0         talph2=0.0          talph3=0.0             talps1=0.0         talps2=0.0            tkcin0=0.0                  tkcin1=0.0                  tkcin2=0.0                  tdifrel=1.0            alpha_liq_sol=1.0                                    Rdefault=tnat*1.0                               Rmethox=1.0
-  H2[17]O  alpha=1.003  tnat=40.000e-6  toce=tnat*(1.0+deltaO18_oce/1000.0)^pente_MWL  tcorr=1.0+fac_enrichoce18*pente_MWL  talph1=talph1_O18  talph2=talph2_O18   talph3=talph3_O18      talps1=talps1_O18  talps2=talps2_O18     tkcin0=tkcin0_O18*fac_kcin  tkcin1=tkcin1_O18*fac_kcin  tkcin2=tkcin2_O18*fac_kcin  tdifrel=1./0.98555     alpha_liq_sol=alpha_liq_sol_O18^fac_coeff_eq17_liq   Rdefault=tnat*(1.0-3.15/1000.)                  Rmethox=tnat*(1.0+230./1000.)  pente_MWL=0.528  fac_kcin=(tdifrel-1.0)/(tdifrel_O18-1.0)
-  H2[18]O  alpha=1.006  tnat=2005.2e-6  toce=tnat*(1.0+deltaO18_oce/1000.0)            tcorr=1.0+fac_enrichoce18            talph1=talph1_O18  talph2=talph2_O18   talph3=talph3_O18      talps1=talps1_O18  talps2=talps2_O18     tkcin0=tkcin0_O18           tkcin1=tkcin1_O18           tkcin2=tkcin2_O18           tdifrel=tdifrel_O18    alpha_liq_sol=alpha_liq_sol_O18                      Rdefault=tnat*(1.0-6.00/1000.)                  Rmethox=tnat*(1.0+130./1000.)  
-  H[2]HO   alpha=1.010  tnat=155.76e-6  toce=tnat*(1.0+deltaO18_oce/1000.0*pente_MWL)  tcorr=1.0+fac_enrichoce18*pente_MWL  talph1=24844.      talph2=-76.248      talph3=52.612E-3       talps1=16288.      talps2=-0.0934        tkcin0=tkcin0_O18*fac_kcin  tkcin1=tkcin1_O18*fac_kcin  tkcin2=tkcin2_O18*fac_kcin  tdifrel=1./0.9755      alpha_liq_sol=1.0212                                 Rdefault=tnat*(1.0+(10.0-6.0*pente_MWL)/1000.)  Rmethox=tnat*(1.0-25.0/1000.)  pente_MWL=8.0    fac_kcin=(tdifrel-1.0)/(tdifrel_O18-1.0)
-  H[3]HO   alpha=1.000  tnat=0.0000     toce=4.0E-19                                   tcorr=1.0                            talph1=46480.      talph2=-103.87      talph3=0.0             talps1=46480.      talps2=-103.87        tkcin0=0.01056              tkcin1=0.0005016            tkcin2=0.0014432            tdifrel=1./0.968       alpha_liq_sol=1.0                                    Rdefault=0.0                                    Rmethox=0.0
 
+  params   deltaO18_oce=0.0        fac_coeff_eq17_liq=0.529                    \
+           fac_enrichoce18=0.0005  fac_coeff_eq17_ice=0.529                    \
+           talph1_O18=1137.        talps1_O18=11.839       tkcin0_O18=0.006    \
+           talph2_O18=-0.4156      talps2_O18=-0.028244    tkcin1_O18=0.000285 \
+           talph3_O18=-2.0667E-3   tdifrel_O18=1./0.9723   tkcin2_O18=0.00082  \
+           alpha_liq_sol_O18=1.00291
+
+  H2[16]O  alpha=1.000            toce=tnat                            \
+           tnat=1.0000            tcorr=1.0                            \
+           talph1=0.0             talps1=0.0               tkcin0=0.0  \
+           talph2=0.0             talps2=0.0               tkcin1=0.0  \
+           talph3=0.0             tdifrel=1.0              tkcin2=0.0  \
+           alpha_liq_sol=1.0      Rdefault=tnat*1.0        Rmethox=1.0
+
+  H2[17]O  alpha=1.003            toce=tnat*(1.0+deltaO18_oce/1000.0)^pente_MWL          \
+           tnat=40.000e-6         tcorr=1.0+fac_enrichoce18*pente_MWL                    \
+           talph1=talph1_O18      talps1=talps1_O18        tkcin0=tkcin0_O18*fac_kcin    \
+           talph2=talph2_O18      talps2=talps2_O18        tkcin1=tkcin1_O18*fac_kcin    \
+           talph3=talph3_O18      tdifrel=1./0.98555       tkcin2=tkcin2_O18*fac_kcin    \
+           alpha_liq_sol=alpha_liq_sol_O18^fac_coeff_eq17_liq                            \
+           Rdefault=tnat*(1.0-3.15/1000.)                  Rmethox=tnat*(1.0+230./1000.) \              
+           fac_kcin=(tdifrel-1.0)/(tdifrel_O18-1.0)        pente_MWL=0.528
+
+  H2[18]O  alpha=1.006            toce=tnat*(1.0+deltaO18_oce/1000.0)         \
+           tnat=2005.2e-6         tcorr=1.0+fac_enrichoce18                   \
+           talph1=talph1_O18      talps1=talps1_O18        tkcin0=tkcin0_O18  \
+           talph2=talph2_O18      talps2=talps2_O18        tkcin1=tkcin1_O18  \
+           talph3=talph3_O18      tdifrel=tdifrel_O18      tkcin2=tkcin2_O18  \
+           alpha_liq_sol=alpha_liq_sol_O18                                    \
+           Rdefault=tnat*(1.0-6.00/1000.)                  Rmethox=tnat*(1.0+130./1000.)  
+
+  H[2]HO   alpha=1.010            toce=tnat*(1.0+deltaO18_oce/1000.0*pente_MWL)          \
+           tnat=155.76e-6         tcorr=1.0+fac_enrichoce18*pente_MWL                    \
+           talph1=24844.          talps1=16288.            tkcin0=tkcin0_O18*fac_kcin    \
+           talph2=-76.248         talps2=-0.0934           tkcin1=tkcin1_O18*fac_kcin    \
+           talph3=52.612E-3       tdifrel=1./0.9755        tkcin2=tkcin2_O18*fac_kcin    \
+           alpha_liq_sol=1.0212                                                          \
+           Rdefault=tnat*(1.0+(10.0-6.0*pente_MWL)/1000.)  Rmethox=tnat*(1.0-25.0/1000.) \
+           fac_kcin=(tdifrel-1.0)/(tdifrel_O18-1.0)        pente_MWL=8.0
+
+  H[3]HO   alpha=1.000            toce=4.0E-19                               \
+           tnat=0.0000            tcorr=1.0                                  \
+           talph1=46480.          talps1=46480.            tkcin0=0.01056    \
+           talph2=-103.87         talps2=-103.87           tkcin1=0.0005016  \
+           talph3=0.0             tdifrel=1./0.968         tkcin2=0.0014432  \
+           alpha_liq_sol=1.0      Rdefault=0.0             Rmethox=0.0
+